diff --git a/doc/bashref.info b/doc/bashref.info
index 9d006e78..d07bc7c8 100644
--- a/doc/bashref.info
+++ b/doc/bashref.info
@@ -2,9 +2,9 @@ This is bashref.info, produced by makeinfo version 6.4 from
 bashref.texi.
 
 This text is a brief description of the features that are present in the
-Bash shell (version 4.4, 23 June 2017).
+Bash shell (version 4.4, 7 October 2017).
 
-   This is Edition 4.4, last updated 23 June 2017, of 'The GNU Bash
+   This is Edition 4.4, last updated 7 October 2017, of 'The GNU Bash
 Reference Manual', for 'Bash', Version 4.4.
 
    Copyright (C) 1988-2017 Free Software Foundation, Inc.
@@ -27,10 +27,10 @@ Bash Features
 *************
 
 This text is a brief description of the features that are present in the
-Bash shell (version 4.4, 23 June 2017).  The Bash home page is
+Bash shell (version 4.4, 7 October 2017).  The Bash home page is
 <http://www.gnu.org/software/bash/>.
 
-   This is Edition 4.4, last updated 23 June 2017, of 'The GNU Bash
+   This is Edition 4.4, last updated 7 October 2017, of 'The GNU Bash
 Reference Manual', for 'Bash', Version 4.4.
 
    Bash contains features that appear in other popular shells, and some
@@ -2551,11 +2551,11 @@ taken.
      '$PATH' is performed only if the command is not found in the hash
      table.  If the search is unsuccessful, the shell searches for a
      defined shell function named 'command_not_found_handle'.  If that
-     function exists, it is invoked with the original command and the
-     original command's arguments as its arguments, and the function's
-     exit status becomes the exit status of the shell.  If that function
-     is not defined, the shell prints an error message and returns an
-     exit status of 127.
+     function exists, it is invoked in a separate execution environment
+     with the original command and the original command's arguments as
+     its arguments, and the function's exit status becomes the exit
+     status of that subshell.  If that function is not defined, the
+     shell prints an error message and returns an exit status of 127.
 
   4. If the search is successful, or if the command name contains one or
      more slashes, the shell executes the named program in a separate
@@ -11504,134 +11504,134 @@ D.5 Concept Index
 
 
 Tag Table:
-Node: Top889
-Node: Introduction2801
-Node: What is Bash?3017
-Node: What is a shell?4131
-Node: Definitions6669
-Node: Basic Shell Features9620
-Node: Shell Syntax10839
-Node: Shell Operation11865
-Node: Quoting13158
-Node: Escape Character14458
-Node: Single Quotes14943
-Node: Double Quotes15291
-Node: ANSI-C Quoting16569
-Node: Locale Translation17828
-Node: Comments18724
-Node: Shell Commands19342
-Node: Simple Commands20214
-Node: Pipelines20845
-Node: Lists23777
-Node: Compound Commands25516
-Node: Looping Constructs26528
-Node: Conditional Constructs29023
-Node: Command Grouping40078
-Node: Coprocesses41557
-Node: GNU Parallel43389
-Node: Shell Functions47363
-Node: Shell Parameters54562
-Node: Positional Parameters58975
-Node: Special Parameters59875
-Node: Shell Expansions63212
-Node: Brace Expansion65335
-Node: Tilde Expansion68169
-Node: Shell Parameter Expansion70517
-Node: Command Substitution84694
-Node: Arithmetic Expansion86049
-Node: Process Substitution86981
-Node: Word Splitting88101
-Node: Filename Expansion90045
-Node: Pattern Matching92419
-Node: Quote Removal96405
-Node: Redirections96700
-Node: Executing Commands106258
-Node: Simple Command Expansion106928
-Node: Command Search and Execution108858
-Node: Command Execution Environment111194
-Node: Environment114178
-Node: Exit Status115837
-Node: Signals117507
-Node: Shell Scripts119474
-Node: Shell Builtin Commands121989
-Node: Bourne Shell Builtins124027
-Node: Bash Builtins144682
-Node: Modifying Shell Behavior173591
-Node: The Set Builtin173936
-Node: The Shopt Builtin184349
-Node: Special Builtins200684
-Node: Shell Variables201663
-Node: Bourne Shell Variables202100
-Node: Bash Variables204204
-Node: Bash Features233997
-Node: Invoking Bash234896
-Node: Bash Startup Files240882
-Node: Interactive Shells245985
-Node: What is an Interactive Shell?246395
-Node: Is this Shell Interactive?247044
-Node: Interactive Shell Behavior247859
-Node: Bash Conditional Expressions251347
-Node: Shell Arithmetic255713
-Node: Aliases258530
-Node: Arrays261078
-Node: The Directory Stack266240
-Node: Directory Stack Builtins267024
-Node: Controlling the Prompt269992
-Node: The Restricted Shell272754
-Node: Bash POSIX Mode274579
-Node: Job Control284930
-Node: Job Control Basics285390
-Node: Job Control Builtins290358
-Node: Job Control Variables295085
-Node: Command Line Editing296241
-Node: Introduction and Notation297912
-Node: Readline Interaction299535
-Node: Readline Bare Essentials300726
-Node: Readline Movement Commands302509
-Node: Readline Killing Commands303469
-Node: Readline Arguments305387
-Node: Searching306431
-Node: Readline Init File308617
-Node: Readline Init File Syntax309764
-Node: Conditional Init Constructs329951
-Node: Sample Init File332476
-Node: Bindable Readline Commands335593
-Node: Commands For Moving336797
-Node: Commands For History338646
-Node: Commands For Text342941
-Node: Commands For Killing346330
-Node: Numeric Arguments348811
-Node: Commands For Completion349950
-Node: Keyboard Macros354141
-Node: Miscellaneous Commands354828
-Node: Readline vi Mode360781
-Node: Programmable Completion361688
-Node: Programmable Completion Builtins369149
-Node: A Programmable Completion Example379035
-Node: Using History Interactively384286
-Node: Bash History Facilities384970
-Node: Bash History Builtins387971
-Node: History Interaction392263
-Node: Event Designators395325
-Node: Word Designators396544
-Node: Modifiers398181
-Node: Installing Bash399583
-Node: Basic Installation400720
-Node: Compilers and Options403411
-Node: Compiling For Multiple Architectures404152
-Node: Installation Names405815
-Node: Specifying the System Type406633
-Node: Sharing Defaults407349
-Node: Operation Controls408022
-Node: Optional Features408980
-Node: Reporting Bugs419506
-Node: Major Differences From The Bourne Shell420700
-Node: GNU Free Documentation License437552
-Node: Indexes462729
-Node: Builtin Index463183
-Node: Reserved Word Index470010
-Node: Variable Index472458
-Node: Function Index488136
-Node: Concept Index501439
+Node: Top893
+Node: Introduction2809
+Node: What is Bash?3025
+Node: What is a shell?4139
+Node: Definitions6677
+Node: Basic Shell Features9628
+Node: Shell Syntax10847
+Node: Shell Operation11873
+Node: Quoting13166
+Node: Escape Character14466
+Node: Single Quotes14951
+Node: Double Quotes15299
+Node: ANSI-C Quoting16577
+Node: Locale Translation17836
+Node: Comments18732
+Node: Shell Commands19350
+Node: Simple Commands20222
+Node: Pipelines20853
+Node: Lists23785
+Node: Compound Commands25524
+Node: Looping Constructs26536
+Node: Conditional Constructs29031
+Node: Command Grouping40086
+Node: Coprocesses41565
+Node: GNU Parallel43397
+Node: Shell Functions47371
+Node: Shell Parameters54570
+Node: Positional Parameters58983
+Node: Special Parameters59883
+Node: Shell Expansions63220
+Node: Brace Expansion65343
+Node: Tilde Expansion68177
+Node: Shell Parameter Expansion70525
+Node: Command Substitution84702
+Node: Arithmetic Expansion86057
+Node: Process Substitution86989
+Node: Word Splitting88109
+Node: Filename Expansion90053
+Node: Pattern Matching92427
+Node: Quote Removal96413
+Node: Redirections96708
+Node: Executing Commands106266
+Node: Simple Command Expansion106936
+Node: Command Search and Execution108866
+Node: Command Execution Environment111242
+Node: Environment114226
+Node: Exit Status115885
+Node: Signals117555
+Node: Shell Scripts119522
+Node: Shell Builtin Commands122037
+Node: Bourne Shell Builtins124075
+Node: Bash Builtins144730
+Node: Modifying Shell Behavior173639
+Node: The Set Builtin173984
+Node: The Shopt Builtin184397
+Node: Special Builtins200732
+Node: Shell Variables201711
+Node: Bourne Shell Variables202148
+Node: Bash Variables204252
+Node: Bash Features234045
+Node: Invoking Bash234944
+Node: Bash Startup Files240930
+Node: Interactive Shells246033
+Node: What is an Interactive Shell?246443
+Node: Is this Shell Interactive?247092
+Node: Interactive Shell Behavior247907
+Node: Bash Conditional Expressions251395
+Node: Shell Arithmetic255761
+Node: Aliases258578
+Node: Arrays261126
+Node: The Directory Stack266288
+Node: Directory Stack Builtins267072
+Node: Controlling the Prompt270040
+Node: The Restricted Shell272802
+Node: Bash POSIX Mode274627
+Node: Job Control284978
+Node: Job Control Basics285438
+Node: Job Control Builtins290406
+Node: Job Control Variables295133
+Node: Command Line Editing296289
+Node: Introduction and Notation297960
+Node: Readline Interaction299583
+Node: Readline Bare Essentials300774
+Node: Readline Movement Commands302557
+Node: Readline Killing Commands303517
+Node: Readline Arguments305435
+Node: Searching306479
+Node: Readline Init File308665
+Node: Readline Init File Syntax309812
+Node: Conditional Init Constructs329999
+Node: Sample Init File332524
+Node: Bindable Readline Commands335641
+Node: Commands For Moving336845
+Node: Commands For History338694
+Node: Commands For Text342989
+Node: Commands For Killing346378
+Node: Numeric Arguments348859
+Node: Commands For Completion349998
+Node: Keyboard Macros354189
+Node: Miscellaneous Commands354876
+Node: Readline vi Mode360829
+Node: Programmable Completion361736
+Node: Programmable Completion Builtins369197
+Node: A Programmable Completion Example379083
+Node: Using History Interactively384334
+Node: Bash History Facilities385018
+Node: Bash History Builtins388019
+Node: History Interaction392311
+Node: Event Designators395373
+Node: Word Designators396592
+Node: Modifiers398229
+Node: Installing Bash399631
+Node: Basic Installation400768
+Node: Compilers and Options403459
+Node: Compiling For Multiple Architectures404200
+Node: Installation Names405863
+Node: Specifying the System Type406681
+Node: Sharing Defaults407397
+Node: Operation Controls408070
+Node: Optional Features409028
+Node: Reporting Bugs419554
+Node: Major Differences From The Bourne Shell420748
+Node: GNU Free Documentation License437600
+Node: Indexes462777
+Node: Builtin Index463231
+Node: Reserved Word Index470058
+Node: Variable Index472506
+Node: Function Index488184
+Node: Concept Index501487
 
 End Tag Table
diff --git a/doc/bashref.ps b/doc/bashref.ps
index 944ca43d..5d8a822b 100644
--- a/doc/bashref.ps
+++ b/doc/bashref.ps
@@ -1,7 +1,7 @@
 %!PS-Adobe-2.0
 %%Creator: dvips(k) 5.997 Copyright 2017 Radical Eye Software
 %%Title: bashref.dvi
-%%CreationDate: Thu Oct  5 18:35:29 2017
+%%CreationDate: Mon Oct  9 19:38:37 2017
 %%Pages: 182
 %%PageOrder: Ascend
 %%BoundingBox: 0 0 612 792
@@ -12,7 +12,7 @@
 %DVIPSWebPage: (www.radicaleye.com)
 %DVIPSCommandLine: dvips -D 600 -t letter -o bashref.ps bashref.dvi
 %DVIPSParameters: dpi=600
-%DVIPSSource:  TeX output 2017.10.05:1435
+%DVIPSSource:  TeX output 2017.10.09:1538
 %%BeginProcSet: tex.pro 0 0
 %!
 /TeXDict 300 dict def TeXDict begin/N{def}def/B{bind def}N/S{exch}N/X{S
@@ -7596,7 +7596,7 @@ ifelse
 TeXDict begin 1 0 bop 150 1318 a Fv(Bash)64 b(Reference)j(Man)-5
 b(ual)p 150 1385 3600 34 v 2361 1481 a Fu(Reference)31
 b(Do)s(cumen)m(tation)i(for)d(Bash)2428 1589 y(Edition)h(4.4,)g(for)f
-Ft(Bash)g Fu(V)-8 b(ersion)31 b(4.4.)3350 1697 y(June)e(2017)150
+Ft(Bash)g Fu(V)-8 b(ersion)31 b(4.4.)3217 1697 y(Octob)s(er)f(2017)150
 4927 y Fs(Chet)45 b(Ramey)-11 b(,)46 b(Case)g(W)-11 b(estern)46
 b(Reserv)l(e)g(Univ)l(ersit)l(y)150 5068 y(Brian)f(F)-11
 b(o)l(x,)45 b(F)-11 b(ree)45 b(Soft)l(w)l(are)h(F)-11
@@ -7604,10 +7604,10 @@ b(oundation)p 150 5141 3600 17 v eop end
 %%Page: 2 2
 TeXDict begin 2 1 bop 150 4279 a Fu(This)35 b(text)h(is)g(a)g(brief)f
 (description)h(of)f(the)h(features)g(that)g(are)g(presen)m(t)g(in)f
-(the)h(Bash)f(shell)h(\(v)m(ersion)150 4389 y(4.4,)c(23)f(June)e
-(2017\).)150 4523 y(This)34 b(is)h(Edition)g(4.4,)i(last)e(up)s(dated)f
-(23)h(June)f(2017,)k(of)d Fr(The)f(GNU)i(Bash)f(Reference)g(Man)m(ual)p
-Fu(,)i(for)150 4633 y Ft(Bash)p Fu(,)29 b(V)-8 b(ersion)31
+(the)h(Bash)f(shell)h(\(v)m(ersion)150 4389 y(4.4,)c(7)e(Octob)s(er)h
+(2017\).)150 4523 y(This)d(is)h(Edition)h(4.4,)g(last)g(up)s(dated)e(7)
+i(Octob)s(er)f(2017,)i(of)e Fr(The)g(GNU)h(Bash)f(Reference)h(Man)m
+(ual)p Fu(,)g(for)150 4633 y Ft(Bash)p Fu(,)f(V)-8 b(ersion)31
 b(4.4.)150 4767 y(Cop)m(yrigh)m(t)602 4764 y(c)577 4767
 y Fq(\015)f Fu(1988{2017)35 b(F)-8 b(ree)31 b(Soft)m(w)m(are)h(F)-8
 b(oundation,)31 b(Inc.)390 4902 y(P)m(ermission)21 b(is)f(gran)m(ted)h
@@ -10878,13 +10878,14 @@ y(a)m(v)m(oid)e(m)m(ultiple)f Ft(PATH)f Fu(searc)m(hes)i(\(see)f(the)g
 (table.)39 b(If)25 b(the)f(searc)m(h)i(is)e(unsuccessful,)h(the)g
 (shell)g(searc)m(hes)330 3039 y(for)e(a)h(de\014ned)e(shell)h(function)
 h(named)e Ft(command_not_found_handle)p Fu(.)32 b(If)23
-b(that)h(function)f(exists,)330 3148 y(it)32 b(is)f(in)m(v)m(ok)m(ed)i
-(with)e(the)h(original)g(command)f(and)g(the)h(original)g(command's)f
-(argumen)m(ts)h(as)g(its)330 3258 y(argumen)m(ts,)h(and)e(the)i
-(function's)e(exit)i(status)g(b)s(ecomes)f(the)g(exit)h(status)f(of)h
-(the)f(shell.)46 b(If)31 b(that)330 3367 y(function)g(is)g(not)g
-(de\014ned,)f(the)i(shell)f(prin)m(ts)f(an)h(error)g(message)h(and)f
-(returns)e(an)i(exit)h(status)g(of)330 3477 y(127.)199
+b(that)h(function)f(exists,)330 3148 y(it)33 b(is)f(in)m(v)m(ok)m(ed)i
+(in)e(a)h(separate)h(execution)f(en)m(vironmen)m(t)g(with)f(the)h
+(original)h(command)e(and)g(the)330 3258 y(original)26
+b(command's)e(argumen)m(ts)h(as)g(its)g(argumen)m(ts,)h(and)e(the)h
+(function's)f(exit)i(status)f(b)s(ecomes)330 3367 y(the)j(exit)g
+(status)g(of)f(that)h(subshell.)39 b(If)27 b(that)h(function)f(is)h
+(not)g(de\014ned,)f(the)g(shell)h(prin)m(ts)f(an)g(error)330
+3477 y(message)k(and)f(returns)f(an)i(exit)g(status)g(of)f(127.)199
 3607 y(4.)61 b(If)33 b(the)g(searc)m(h)h(is)g(successful,)g(or)f(if)g
 (the)h(command)f(name)g(con)m(tains)i(one)f(or)f(more)g(slashes,)i(the)
 330 3716 y(shell)g(executes)h(the)f(named)f(program)g(in)h(a)g
diff --git a/doc/builtins.ps b/doc/builtins.ps
index d16f4ef3..fba031e6 100644
--- a/doc/builtins.ps
+++ b/doc/builtins.ps
@@ -1,6 +1,6 @@
 %!PS-Adobe-3.0
 %%Creator: groff version 1.22.3
-%%CreationDate: Thu Oct  5 14:35:22 2017
+%%CreationDate: Mon Oct  9 15:38:30 2017
 %%DocumentNeededResources: font Times-Roman
 %%+ font Times-Bold
 %%+ font Times-Italic
diff --git a/doc/rbash.ps b/doc/rbash.ps
index bd2cd6bf..b5cff8d3 100644
--- a/doc/rbash.ps
+++ b/doc/rbash.ps
@@ -1,6 +1,6 @@
 %!PS-Adobe-3.0
 %%Creator: groff version 1.22.3
-%%CreationDate: Thu Oct  5 14:35:23 2017
+%%CreationDate: Mon Oct  9 15:38:31 2017
 %%DocumentNeededResources: font Times-Roman
 %%+ font Times-Bold
 %%DocumentSuppliedResources: procset grops 1.22 3
diff --git a/lib/sh/casemod.c b/lib/sh/casemod.c
index 2bf9a95f..7cdd4178 100644
--- a/lib/sh/casemod.c
+++ b/lib/sh/casemod.c
@@ -229,9 +229,9 @@ singlebyte:
       else
 	{
 	  m = mbrtowc (&wc, string + start, end - start, &state);
-	  /* Have to go through case conversion even for single-byte chars, to
-	     accommodate single-byte characters where the corresponding upper
-	     or lower case equivalent is multibyte. */
+	  /* Have to go through wide case conversion even for single-byte
+	     chars, to accommodate single-byte characters where the
+	     corresponding upper or lower case equivalent is multibyte. */
 	  if (MB_INVALIDCH (m))
 	    {
 	      wc = (unsigned char)string[start];
